<template>
    <div class="container-lg mt-3">
        <h2>Formulas</h2>
        <div class="row mt-3">
           <div class="col-md-12 row ">
                <div class="col-md-3 p-2 formula" v-for="(formula, index) in formulas" v-bind:key="index"> 
                    <div class="text-center border-dashed content-formula ">
                       <div class="d-flex justify-content-end">
                           <div class="px-1 py-2 cursor_pointer " @click="onDeleteFormula(formula.id)">
                            <i class="fas fa-trash-alt text-danger pr-2 "></i>
                           </div>
                           <div class="p-2 cursor_pointer"  @click="onEditFormula(formula)">
                             <i class="fas fa-edit text-success " ></i>
                           </div>
                       </div>
                        <h1 class="text-secondary fw-bold mt-2">{{formula.name}}</h1>
                    </div>
                </div>
                <div class="col-md-3 p-2 formula cursor_pointer" @click="onshowModal" > 
                    <div class="text-center border-dashed border-blue content-formula py-5 ">
                        <h1 class="text-blue fw-bold"><i class="fas fa-plus-circle"></i> Add</h1>
                    </div>
                </div>
           </div>
        </div>
        <modal v-if="showModal" btnCancelText="Cancelar" size="lg" btnAcceptText="Grabar" title="Nueva Formula" @accept="onSaveFormula" @close="showModal=false" >
            <div class="form-floating mb-3">
                <input type="text" class="form-control" v-model="name" placeholder="nombre">
                <label >Nombre</label>
                <span class="text-danger" v-if="validationName">you must complete this field</span>
            </div>
            <div class="form-floating">
                <input type="text" class="form-control" v-model="formula_val" placeholder="formula">
                <label >Formula</label>
                <span class="text-danger" v-if="validationFormula">you must complete this field</span>
                <span class="text-danger" v-if="validationCalcFormula">formula no valid</span>
            </div>
        </modal>
    </div>    
</template>
<script>
import modal from '../../components/modal.vue'
import { apiCallList } from '../../mixins'

export default {
    mixins: [apiCallList],
    components: { modal },
    data(){
        return {
            showModal : false,
            formulas : [],
            endpoint : "api/formulas",
            name : "",
            formula_val : "",
            validationName : false,
            validationFormula : false,
            validationCalcFormula : false,
            formula_id : null
        }
    },
    methods: {
        onshowModal(){
        this.name = "";
        this.formula_val = "";
        this.formula_id = null;
        this.showModal = true;  
        },
        loadItems (){
            this.formulas = this.data.formulas;
        },
        onSaveFormula(){
            if(this.validations()){
                let data = {
                    name : this.name,
                    value : this.formula_val
                };
                if(this.formula_id)
                    this.$axios.put("/api/formulas/"+this.formula_id,data)
                        .then(() => {
                            this.fetch()
                            this.showModal = false;
                        })
                        .catch(() =>{

                        })
                else
                    this.$axios.post("/api/formulas",data)
                        .then(() => {
                            this.fetch()
                            this.showModal = false;
                        })
                        .catch(() => {

                        })
            }
        
        },
        validations(){
            this.validationName = false;
            this.validationFormula = false;
            this.validationCalcFormula = false;
            if(!this.name){
                this.validationName = true;
                return false;
            }
            if(!this.formula_val){
                this.validationFormula = true;
                return false;
            }
                try {
                   isNaN(eval("100"+this.formula_val)); 
                } catch (e) {
                    if (e instanceof SyntaxError) {
                        this.validationCalcFormula = true;
                        return false;
                    }
                }
            return true;
        },
        onDeleteFormula(id){
            this.$axios.delete("/api/formulas/"+id)
                .then(() => {
                    this.fetch()
                })
                .catch(() => {

                })
        },
        onEditFormula(formula){
            this.name = formula.name;
            this.formula_val = formula.value;
            this.formula_id = formula.id;
            this.showModal = true;  
        }
        
        

    }
}
</script>
<style >
.border-dashed{
    border: 4px dashed gray;
}
.cursor_pointer{
    cursor: pointer;
}
.content-formula{
    width: 100%;
    height: 160px;
}
.formula:hover > .content-formula {
    border: dashed 4px #4a8ff5;
}
.formula:hover > .content-formula h1{
    color:#4a8ff5 !important;
}
.border-blue{
    border: dashed 4px #4a8ff5;
}
.text-blue{
    color:#4a8ff5;
}

</style>
